
#ifndef  __JBL_GRAPHIC_IO_H_
#define  __JBL_GRAPHIC_IO_H_


/*
グラフィック用ファイル入出力関数ヘッダ  gio.h v3.1   '07/6/27   (C) Fumi.Iseki
 
  依存関係
      #include "gdata.h"
      #include "tools.h"
    
*/



#include "gdata.h"
#include "tools.h"
#include <sys/stat.h>

extern  RBound ExRBound;



/**/
int   write_wsg_file(char* fn, WSGraph gr); 
int   write_file_rb (char* fn, WSGraph gr, RBound rb);
int   write_ras_file(char* fn, WSGraph gr); 

WSGraph read_wsg_file   (char* fn);
WSGraph read_wsg_file_rb(char* fn, RBound* rb);
WSGraph read_ras_file   (char* fn);


int   write_cmn_file(char* fn, CmnHead* hd);
int   write_ct_file (char* fn, CmnHead* hd); 
int   write_ras_file_obit(char* fn, CmnHead* hd, int obit);

CmnHead  read_xxx_file  (char* fn);
CmnHead  read_cmn_file  (char* fn);
CmnHead  read_cmn_header(char* fn);

CmnHead  read_ras_data (FILE* fp);								// readRasData()	 for C++
CmnHead  read_user_data(FILE* fp, CmnHead* hd);					// readUserSetData() for C++
CmnHead  read_ct_data  (FILE* fp);								// readCTData()		 for C++

int      dicom_header(FILE* fp, int fsize, int* dsize, int* xsize, int* ysize, int* depth, float* rzxy);
WSGraph  read_dicom_file(char* fn);

/**/


#endif




