/* vi: set tabstop=4 nocindent paste: */

#ifndef  DISABLE_BERKELEYDB

#ifndef  __JBL_BERKELEY_DB4_H__
#define  __JBL_BERKELEY_DB4_H__


/**
簡易データベースライブラリヘッダ for Berkeley DB4: bdb_tool.h


  依存関係
      #include "buffer.h"
      #include "tlist.h"

  ライブラリ
	  -ldb-4.2  for Berkeley DB4


  Berkeley DBのマニュアル
		http://pybsddb.sourceforge.net/reftoc.html

*/





#include "common.h"

#if ! defined (HAVE_DB_H) && ! defined (HAVE_LIBDB_4_2)
	#error  fdb.h needs Berkley 
#endif


#include "buffer.h"
#include "tlist.h"


#ifdef HAVE_DB_H 
	#define DB_DBM_HSEARCH  1
	#include <db.h>
#endif


#include <fcntl.h>



/**/

///////////////////////////////////////////////////////////////////////////////////
//

DB*		open_fdb(char* fname, unsigned int mode);
void	close_fdb(DB** dp);

#define	flush_fdb(d)	(d)->sync((d), 0)

int     set_fdb_data(DB* dp, Buffer id, Buffer dbdata);
int     del_fdb_data(DB* dp, Buffer id);
Buffer  get_fdb_data(DB* dp, Buffer id);



///////////////////////////////////////////////////////////////////////
// for file

int     check_fdb_file(char* fname);
int     set_fdb_data_file(char* fname, Buffer id, Buffer dbdata);
int     del_fdb_data_file(char* fname, Buffer id);
Buffer  get_fdb_data_file(char* fname, Buffer id);



///////////////////////////////////////////////////////////////////////
//

tList*	get_all_fdb_data(DB* dp);
tList*	get_all_fdb_data_file(char* fname);






/**/

#endif
#endif


